/* Tennis Tournament Management System 2005 by Silvio Moioli
    and Davide Gottini (moio@tiscali.it, davide.gottini@virgilio.it).

	


	ATTENZIONE: questa è la versione DEBUG del programma, pertanto non
	contiene alcuni dei cambiamenti che sono inglogati nella versione
	RELEASE. Si consiglia di usare sempre e solo la versione RELEASE.

	Questa versione è stata pubblicata SOLO per documentare le fasi intermedie
	del lavoro con le assertions e i programmi di prova (come descritto nella
	documentazione)!!!


 */
#include <cstdlib>
#include <fstream>
#include <iostream>
#include <cassert>
using namespace std;

#ifndef TT_FILE
#define TT_FILE

/**
 * Aggiungere un campo in coda al file.
 * 
 * @param nomeFile stringa terminata da ' \\0' con il nome del file a
 * cui aggiungere il campo, completo di percorso.
 * @param s campo da inserire anch'esso in formato stringa
 */
void fileAggiungiCampo(const char* nomeFile, const char* s);

/**
 * Aggiungere un campo in coda al file, sovrascrivendo l'ultimo campo
 * dell'ultimo record presente.
 * Suppone che l'ultimo record del file abbia un solo campo.
 * 
 * @param nomeFile stringa terminata da ' \\0' con il nome del file a
 * cui aggiungere il campo, completo di percorso.
 * @param s campo da inserire anch'esso in formato stringa
 */
void fileSovrascriviUltimoCampo(const char* nomeFile, const char* s);

/**
 * Chiude il record corrente. La prossima operazione di fileAggiungiCampo
 * avverr&agrave; su un nuovo record.
 * 
 * @param nomeFile stringa terminata da ' \\0' con il nome del file a
 * cui aggiungere il record, completo di percorso.
 */
void fileNuovoRecord(const char* nomeFile);

/**
 * Legge e ritorna l'x-esimo campo nell'y-esimo record del file in formato
 * stringa.
 * 
 * @param nomeFile stringa terminata da ' \\0' con il nome del file da
 * cui leggere il campo, completo di percorso.
 * @param x l'indice del campo
 * @param y l'indice del record
 * @return una stringa appena allocata contenente il dato letto
 */
char* fileLeggiCampo(const char* nomeFile, int x, int y);//0<=x,y<n

/**
 * Conta il numero di record all'interno del file.
 * 
 * @param nomeFile stringa terminata da ' \\0' con il nome del file,
 *  completo di percorso.
 * @return il numero di record presenti nel file
 */
int fileContaRecord(const char* nomeFile);

/**
 * Controlla l'esistenza di un file.
 * 
 * @param nomeFile stringa terminata da ' \\0' con il nome del file da
 * controllare, completo di percorso.
 * @return true se il file esiste, false altrimenti.
 */
bool fileEsiste(const char* nomeFile);

/**
 * Legge e ritorna l'ultimo carattere in un file, prima dell'eof.
 * 
 * @param nomeFile stringa terminata da ' \\0' con il nome del file,
 *  completo di percorso.
 * @return l'ultimo carattere nel file
 */
char fileUltimoCarattere(const char* nomeFile);

#endif

