/* Tennis Tournament Management System 2005 by Silvio Moioli
    and Davide Gottini (moio@tiscali.it, davide.gottini@virgilio.it).

	


	ATTENZIONE: questa è la versione DEBUG del programma, pertanto non
	contiene alcuni dei cambiamenti che sono inglogati nella versione
	RELEASE. Si consiglia di usare sempre e solo la versione RELEASE.

	Questa versione è stata pubblicata SOLO per documentare le fasi intermedie
	del lavoro con le assertions e i programmi di prova (come descritto nella
	documentazione)!!!


 */
 #include "menu.h"

void menuPrincipale(const char* nomeFileGiocatori, const char* nomeFilePartite)
{
	bool uscita = false;
	while (!uscita){
	    stringstream ss (stringstream::in | stringstream::out);
	    ss<<"MENU' PRINCIPALE: "<<" Turno: "<<parTurnoCorrente(nomeFilePartite);
	    ss<<" Giocate finora "<<parContaPartite(nomeFilePartite)<<" partite";
	    const char* tmp = ss.str().c_str();
	    uiStampaTitolo(tmp);
	    
	    Lista *menu=listeCreaLista("Passa al Menu Turno");
	    listeAggiungiElemento(menu,"Passa al Menu Giocatori");
	    listeAggiungiElemento(menu,"Visualizza le partite dell'intero torneo");
	    listeAggiungiElemento(menu,"Esci da TennisTournament");     
	    uiStampaMenu(menu);
	    listeDistruggiLista(menu);
	    
	    switch(uiChiediScelta(4)){
			case 1:	menuTurno(nomeFileGiocatori, nomeFilePartite);
	                break;
			case 2:	menuGiocatori(nomeFileGiocatori, nomeFilePartite);
	                break;	
			case 3:	partiteTorneo(nomeFileGiocatori,nomeFilePartite);
	                break;
			case 4:	uiStampaTitolo("Grazie di aver usato TennisTournament!");
					uscita=true;
	                break;
            default: assert(false);	                
	   }
	}
}

void menuTurno(const char* nomeFileGiocatori,const char* nomeFilePartite)
{
	bool uscita = false;
	while (!uscita){
	    stringstream ss (stringstream::in | stringstream::out); 
	    int turno = parTurnoCorrente(nomeFilePartite);
	    ss<<"MENU' TURNO: Turno: "<<turno;
	    ss<<"; Giocate finora "<<parPartiteGiocate(nomeFilePartite, turno)<<" partite";
	    const char* tmp = ss.str().c_str();
	    uiStampaTitolo(tmp);
	    
	    Lista *menu=listeCreaLista("Nuova partita");
	    listeAggiungiElemento(menu,"Visualizza le partite giocate in questo turno (e i risultati)");
	    listeAggiungiElemento(menu,"Chiudi il turno");
	    listeAggiungiElemento(menu,"Visualizza i dettagli di un turno passato");     
	    listeAggiungiElemento(menu,"Torna al Menu Principale");     
	    uiStampaMenu(menu);
	    listeDistruggiLista(menu);
	    
	    switch(uiChiediScelta(5)){
			case 1: menuNuovaPartita(nomeFileGiocatori,nomeFilePartite);
	                break;
			case 2:	partiteGiocateTurno(turno, nomeFileGiocatori, nomeFilePartite);
	                break;	
			case 3:	chiudiTurno(turno,nomeFileGiocatori,nomeFilePartite);   
	                break;
			case 4:	turniPassati(nomeFileGiocatori,nomeFilePartite);
	                break;
			case 5:	uscita=true;
	                break;
	        default: assert(false);
	        }     
	}
}

/**
 * Inizializza la partita, il menu è richiamato
 * 
 * */
void menuNuovaPartita(const char* nomeFileGiocatori,const char* nomeFilePartite){
     if( (!fileEsiste(nomeFileGiocatori)) || (fileContaRecord(nomeFileGiocatori)<2) ){
	     cout<<"Non ci sono abbastanza giocatori iscritti al torneo!"<<endl;
	     uiChiediConferma();
	 }
     else{
		Lista *liberi=giocGiocatoriLiberi(nomeFileGiocatori,nomeFilePartite);
		if(liberi->n<2){
			for (int i=0; i<liberi->n; i++){
				const Giocatore* g =  (Giocatore* ) listeLeggiElemento(liberi, i);
				delete[] g->nome;
				delete g;
			}
            listeDistruggiLista(liberi);
	        cout<<"Non ci sono abbastanza giocatori liberi!"<<endl;
    	     uiChiediConferma();
		}
		else{
			//Ci sono abbastanza giocatori e sono liberi. Creiamo la partita di default.
	        Giocatore *gioc1=(Giocatore *) listeLeggiElemento(liberi,0);
    	    Giocatore *gioc2=(Giocatore *) listeLeggiElemento(liberi,1);
    	    Partita *nuova=new Partita;
		    nuova->turno=parTurnoCorrente(nomeFilePartite);
		    nuova->idG1=gioc1->id;
		    nuova->idG2=gioc2->id;
		    nuova->risG1=1;
		    nuova->risG2=2;
			for (int i=0; i<liberi->n; i++){
				Giocatore* g =  (Giocatore* ) listeLeggiElemento(liberi, i);
				delete[] g->nome;
				delete g;
			}
            listeDistruggiLista(liberi);
    	    if (menuNuovaPartitaMostra(nomeFileGiocatori, nomeFilePartite, nuova)){
	    	    //Salviamo le scelte su file
	    	    parNuovaPartita(nomeFileGiocatori, nomeFilePartite, nuova->idG1, nuova->idG2,
	    	    nuova->risG1,nuova->risG2);
    	    }
     	    delete nuova;
		}
     }
}

/**
 * Restituisce true se l'utente vuole salvare la partita, false per annullare.
 * 
 * 
 * */
bool menuNuovaPartitaMostra(const char* nomeFileGiocatori,
 const char* nomeFilePartite, Partita* p){
 	bool uscita = false;
 	bool risultato = false;
	while (!uscita){
	    int turno=parTurnoCorrente(nomeFilePartite);
	    int partite=parPartiteGiocate(nomeFilePartite, turno); 
	    stringstream ss (stringstream::in | stringstream::out); 
	    ss<<"Nuova partita nel turno numero: "<<turno<<" Giocate finora "<<partite<<" partite";
	    const char* tmp = ss.str().c_str();
	    uiStampaTitolo(tmp);
	    
	    tmp = giocNomeGiocatore(nomeFileGiocatori,p->idG1);
	    cout<<"Giocatore 1: "<<tmp<<" -- Risultato "<<p->risG1<<endl;
	    delete[] tmp;
	    tmp = giocNomeGiocatore(nomeFileGiocatori,p->idG2);
	    cout<<"Giocatore 2: "<<tmp<<" -- Risultato "<<p->risG2<<endl;
	    delete[] tmp;
	
	    Lista *menu=listeCreaLista("Cambia Giocatore 1");
	    listeAggiungiElemento(menu,"Cambia Giocatore 2");
	    listeAggiungiElemento(menu,"Imposta Risultato Giocatore 1");
	    listeAggiungiElemento(menu,"Imposta Risultato Giocatore 2"); 
	    listeAggiungiElemento(menu,"Conferma e Salva Parita");    
	    listeAggiungiElemento(menu,"Annulla Partita e torna al Menu Turno");     
	    uiStampaMenu(menu);
	    listeDistruggiLista(menu);
	    
	    switch(uiChiediScelta(6)){
			case 1:
			        p->idG1 = cambiaGiocatore(nomeFileGiocatori,nomeFilePartite,p,1);
	                break;
			case 2:
			        p->idG2 = cambiaGiocatore(nomeFileGiocatori,nomeFilePartite,p,2);
	                break;	
			case 3:
	                p->risG1=cambiaRisultato(p,1);
	                break;
			case 4:
	                p->risG2=cambiaRisultato(p,2);
	                break;
			case 5:	uscita=true; risultato=true;
	                break;
	        case 6: uscita=true; risultato= false;
	                break;
            default: assert(false);	                
	    }     
	}
	return risultato;
}

int cambiaGiocatore(const char* nomeFileGiocatori,const char* nomeFilePartite,
Partita* p, int daCambiare)
{
	int risultato = -1;
	//Lista dei giocatori liberi (tutti)
    Lista* liberi=giocGiocatoriLiberi(nomeFileGiocatori,nomeFilePartite);
    if (liberi->n<3){
    	//Non è possibile effettuare altra scelta se non i giocatori correnti.
    	if (daCambiare == 1){
    		risultato = p->idG1;
    	}
    	else{
    		risultato = p->idG2;
    	}
    }
    else{
    	uiStampaTitolo("Scegli il concorrente");
	    //Lista delle voci di menu
	    Lista* menu=listeCreaLista(NULL);
	    //Lista degli id dei giocatori, tranne quelli già scelti
	    Lista* possibili=listeCreaLista(NULL);
	    for (int i=0;i<liberi->n;i++)
	    {
	       Giocatore* g=(Giocatore *)listeLeggiElemento(liberi,i);
	       if (g->id != p->idG1 && g->id != p->idG2)
	       {       
	          listeAggiungiElemento(menu,g->nome);
	          listeAggiungiElemento(possibili,&(g->id));
	       }  
	    }
	    uiStampaMenu(menu);
	    
	    if (liberi->n==3){
	    	risultato = *( (int*)listeLeggiElemento(possibili,0));
	    }
	    else{
		    int scelta = uiChiediScelta(menu->n);
		    risultato = *( (int*)listeLeggiElemento(possibili,scelta-1) );
	    }
	
	    listeDistruggiLista(menu);
	    listeDistruggiLista(possibili);
    }
    
    for (int i=0; i<liberi->n; i++){
		Giocatore* g = (Giocatore*) listeLeggiElemento(liberi, i);
		delete[] g->nome;
		delete g;
	}	    
    listeDistruggiLista(liberi);
    
    assert (risultato != -1);
    return risultato;
}

int cambiaRisultato(Partita* p, int daCambiare){
    uiStampaTitolo("Inserire il risultato della partita");
    int risultato=uiChiediScelta(6);
    if (daCambiare == 1 && risultato == p->risG2){
        cout<<"Nei tornei a eliminazione diretta non sono ammessi i pareggi."<<endl;
        uiChiediConferma();
        return p->risG1;
    }
    if (daCambiare == 2 && risultato == p->risG1){
        cout<<"Nei tornei a eliminazione diretta non sono ammessi i pareggi."<<endl;
        uiChiediConferma();
        return p->risG2;
    }
    return risultato;
}

void partiteGiocateTurno(int turno, const char* nomeFileGiocatori, const char* nomeFilePartite)
{
     assert(turno>0 && turno<100);
     int partite = parPartiteGiocate(nomeFilePartite,turno);
     if(partite>0){
           stringstream ss (stringstream::in | stringstream::out); 
           ss<<"Nel turno numero "<<turno<<" sono state giocate ";
           ss<<partite<<" partite";
           const char* tmp = ss.str().c_str();
           uiStampaTitolo(tmp);
           Lista* giocate=parListaPartiteGiocate(nomeFilePartite, turno);
           assert(giocate->n==partite);
           for(int i=0;i<giocate->n;i++) {
              Partita* partita=(Partita*)listeLeggiElemento(giocate,i);
              char* temp = giocNomeGiocatore(nomeFileGiocatori,partita->idG1);
              cout<<temp;
              delete[] temp;
              cout<<" "<<partita->risG1<<endl;
              temp = giocNomeGiocatore(nomeFileGiocatori,partita->idG2);
              cout<<temp;
              delete[] temp;
              cout<<" "<<partita->risG2<<endl<<endl;
              delete partita;
           }
           listeDistruggiLista(giocate);
      }
    else{
	    cout<<"Non sono state giocate partite nel turno "<<turno<<endl;
    }
    uiChiediConferma();
}

 
void chiudiTurno(int turno, const char* nomeFileGiocatori,const char* nomeFilePartite)   
{
    if(parPartiteGiocate(nomeFilePartite,turno)!=0) {
		parNuovoTurno(nomeFilePartite);
        cout<<"Turno Chiuso."<<endl;
    }
    else{
       cout<<"Per chiudere il Turno bisogna aver giocato almeno una partita!"<<endl;
    }
    uiChiediConferma();
}             

void turniPassati(const char* nomeFileGiocatori,const char* nomeFilePartite){   
    int turno=parTurnoCorrente(nomeFilePartite);
    if(turno>2)
    {  
       uiStampaTitolo("Visualizzazione turni giocati finora");
       for(int i=1;i<turno;i++) {
            cout<<"Turno "<<i<<": giocate "<<parPartiteGiocate(nomeFilePartite,i)<<" partite"<<endl;
       } 
       cout<<"Immetti il numero del turno da visualizzare:"<<endl;
       partiteGiocateTurno(uiChiediScelta(turno-1), nomeFileGiocatori, nomeFilePartite);
    }
    else{
       if (turno == 2){
	       partiteGiocateTurno(1, nomeFileGiocatori, nomeFilePartite);
       }
       else{
	       cout<<"Siamo al primo turno, non ci sono turni precedenti."<<endl; 
		   uiChiediConferma();
       }
    }
}

void menuGiocatori(const char* nomeFileGiocatori,const char* nomeFilePartite)
{    
 	bool uscita = false;
	while (!uscita){
	    int turno=parTurnoCorrente(nomeFilePartite);
	    int partite=parContaPartite(nomeFilePartite); 
	    stringstream ss (stringstream::in | stringstream::out); 
	    ss<<"MENU' GIOCATORI: "<<" Turno: "<<turno<<"; Giocate finora "<<partite<<" partite";
	    const char* tmp = ss.str().c_str();
	    uiStampaTitolo(tmp);
	    Lista *menu=listeCreaLista(NULL);
	    char* supp="Visualizza l'elenco dei giocatori in torneo";
	    listeAggiungiElemento(menu,supp);
	    listeAggiungiElemento(menu,supp="Visualizza le partite e i risultati di un singolo giocatore");
	    listeAggiungiElemento(menu,supp="Nuovo Giocatore");
	    listeAggiungiElemento(menu,supp="Torna al Menu Principale");     
	    uiStampaMenu(menu);
	    listeDistruggiLista(menu);
	    switch(uiChiediScelta(4)){
			case 1:	giocatoriTorneo(nomeFileGiocatori,nomeFilePartite);
	                break;
			case 2:	dettagliGiocatore(nomeFileGiocatori, nomeFilePartite);
	                break;	
			case 3:	aggiungiGiocatore(nomeFileGiocatori,nomeFilePartite);
	                break;
			case 4:	uscita=true;
	                break;
	    }
	}
}    

void giocatoriTorneo(const char* nomeFileGiocatori,const char* nomeFilePartite){    
    if(fileEsiste(nomeFileGiocatori) && fileContaRecord(nomeFileGiocatori)>0){
     int numGiocatori=fileContaRecord(nomeFileGiocatori);
     stringstream ss (stringstream::in | stringstream::out); 
     ss<<"A questo torneo partecipano "<<numGiocatori<<" giocatori.";
     uiStampaTitolo(ss.str().c_str());
     cout<<endl;
     for (int i=0;i<numGiocatori;i++){
     	char* nome = giocNomeGiocatore(nomeFileGiocatori,i);
     	cout<<nome<<endl;
     	delete[] nome;
     }
    }
    else{
        cout<<"A questo Torneo non partecipa alcun giocatore."<<endl;
    }
    uiChiediConferma();
}

void dettagliGiocatore(const char* nomeFileGiocatori,const char* nomeFilePartite)
{
    if(fileEsiste(nomeFileGiocatori) && fileContaRecord(nomeFileGiocatori)>0){
    	if (fileEsiste(nomeFilePartite)){
		     uiStampaTitolo("Elenco dei giocatori nel Torneo");
		     int numGiocatori=fileContaRecord(nomeFileGiocatori);
		     for (int i=0;i<numGiocatori;i++){
		     	char* nome = giocNomeGiocatore(nomeFileGiocatori,i);
		     	cout<<i+1<<"-"<<nome<<endl;
		     	delete[] nome;
		     }
		     if (numGiocatori==1){
			     carrieraGiocatore(nomeFileGiocatori, nomeFilePartite, 1);
		     }
		     else{
			     carrieraGiocatore(nomeFileGiocatori, nomeFilePartite, uiChiediScelta(numGiocatori)-1);
		     }
    	}
    	else{
	        cout<<"In questo Torneo non sono ancora state giocate partite."<<endl;
		    uiChiediConferma();
    	}
    }
    else{
        cout<<"A questo Torneo non partecipa alcun giocatore."<<endl;
	    uiChiediConferma();
    }
}

void carrieraGiocatore(const char* nomeFileGiocatori,const char* nomeFilePartite,int giocatore)
{
     stringstream ss (stringstream::in | stringstream::out);
     char* nome = giocNomeGiocatore(nomeFileGiocatori,giocatore);
     ss<<"Carriera del giocatore: "<<nome;
     delete[] nome;
     uiStampaTitolo(ss.str().c_str());

     cout<<"Ha giocato contro:"<<endl;
     bool haPerso=false;
     int partite = parContaPartite(nomeFilePartite);
     for(int i=0;i<partite && !haPerso;i++){
        switch(giocHaGiocato(nomeFileGiocatori, nomeFilePartite,giocatore,i))
        {
            case NONGIOCA:break;
            case HAPERSO:
                          cout<<"E' stato battuto (ed eliminato) da: ";
                          haPerso=true;
            case HAVINTO:             			 
            			  Partita* part=parDettagliPartita(nomeFilePartite, i);
                          char* nome = NULL;
                          if(part->idG1==giocatore){
                             nome = giocNomeGiocatore(nomeFileGiocatori,part->idG2);  
                          }
                          else{
                             nome = giocNomeGiocatore(nomeFileGiocatori,part->idG1); 
                          }
                          cout<<nome<<endl;
                          delete[] nome;
                          delete part;
                          break;
         }
     }
     uiChiediConferma();
}

void aggiungiGiocatore(const char* nomeFileGiocatori,const char* nomeFilePartite)
{
	uiStampaTitolo("Inserisci il nome del Giocatore");
    char *nomeGiocatore=uiChiediStringa();
    giocNuovoGiocatore(nomeFileGiocatori,nomeGiocatore);
    delete[] nomeGiocatore;
    cout<<"Giocatore inserito"<<endl;
}

void partiteTorneo(const char* nomeFileGiocatori,const char* nomeFilePartite)
{   
    int turno=parTurnoCorrente(nomeFilePartite);
    int partite=parContaPartite(nomeFilePartite);
    stringstream ss (stringstream::in | stringstream::out); 
    if(partite>0)
    {  
       uiStampaTitolo("Partite del torneo giocate finora:");
       for (int i=1;i<=turno;i++){
           partiteGiocateTurno(i, nomeFileGiocatori, nomeFilePartite);
       }   
    }
    else{
       cout<<"Non sono state giocate partite."<<endl; 
    }
    cout<<"Riepilogo Torneo concluso."<<endl;    
    uiChiediConferma();
}
