/* Tennis Tournament Management System 2005 by Silvio Moioli
    and Davide Gottini (moio@tiscali.it, davide.gottini@virgilio.it).

	


	ATTENZIONE: questa è la versione DEBUG del programma, pertanto non
	contiene alcuni dei cambiamenti che sono inglogati nella versione
	RELEASE. Si consiglia di usare sempre e solo la versione RELEASE.

	Questa versione è stata pubblicata SOLO per documentare le fasi intermedie
	del lavoro con le assertions e i programmi di prova (come descritto nella
	documentazione)!!!


 */
#include "partitatest.h"
#include "partita.h"
#include "file.h"
#include "giocatore.h"

void partitaTest()
{
     char *pathPart ="/home/silvio/Desktop/partita.txt";
     char *pathGioc ="/home/silvio/Desktop/giocatori.txt";
     //serve almeno uno x cominciare
     if (!fileEsiste(pathGioc)){
	     giocNuovoGiocatore(pathGioc, "pippo0");
	     giocNuovoGiocatore(pathGioc, "pippo1");
	     giocNuovoGiocatore(pathGioc, "pippo2");
	     giocNuovoGiocatore(pathGioc, "pippo3");
	     giocNuovoGiocatore(pathGioc, "pippo4");
	     giocNuovoGiocatore(pathGioc, "pippo5");
	     giocNuovoGiocatore(pathGioc, "pippo6");
	     giocNuovoGiocatore(pathGioc, "pippo7");
	     giocNuovoGiocatore(pathGioc, "pippo8");
	     giocNuovoGiocatore(pathGioc, "pippo9");
	     giocNuovoGiocatore(pathGioc, "pippo10");
	     giocNuovoGiocatore(pathGioc, "pippo11");
	     giocNuovoGiocatore(pathGioc, "pippo12");
	     giocNuovoGiocatore(pathGioc, "pippo13");
     }
     
     char* nome = giocNomeGiocatore(pathGioc, 0);
     assert(strcmp(nome,"pippo0")==0);
     delete[] nome;
     nome = giocNomeGiocatore(pathGioc, 7);
     assert(strcmp(nome,"pippo7")==0);
     delete[] nome;
     nome = giocNomeGiocatore(pathGioc, 13);
     assert(strcmp(nome,"pippo13")==0);
     delete[] nome;
     
     
     parNuovaPartita(pathGioc, pathPart, 0, 1, 6, 5);     
     
     Partita* p = parDettagliPartita(pathPart,0);
     assert(p->turno==1);
     assert(p->idG1==0);
     assert(p->idG2==1);
     assert(p->risG1==6);
     assert(p->risG2==5);
     delete p;
     
     
     parNuovaPartita(pathGioc, pathPart, 2, 3, 6, 5);  
     
     p = parDettagliPartita(pathPart,1);
     assert(p->turno==1);
     assert(p->idG1==2);
     assert(p->idG2==3);
     assert(p->risG1==6);
     assert(p->risG2==5);
     delete p;
     
     
     parNuovaPartita(pathGioc, pathPart, 4, 5, 6, 5);
     
     p = parDettagliPartita(pathPart,2);
     assert(p->turno==1);
     assert(p->idG1==4);
     assert(p->idG2==5);
     assert(p->risG1==6);
     assert(p->risG2==5);
     delete p;
     
     
     parNuovaPartita(pathGioc, pathPart, 6, 7, 6, 5);  
     parNuovaPartita(pathGioc, pathPart, 8, 9, 6, 5);  
     parNuovaPartita(pathGioc, pathPart, 10, 11, 6, 5); 
     parNuovaPartita(pathGioc, pathPart, 12, 13, 6, 5);  
     assert(parTurnoCorrente(pathPart)==1);
     
     assert(parPartiteGiocate(pathPart,(parTurnoCorrente(pathPart)))==7);
     parNuovoTurno(pathPart);
     assert(parTurnoCorrente(pathPart)==2);
     parNuovaPartita(pathGioc, pathPart, 0, 2, 6, 5);     
     parNuovaPartita(pathGioc, pathPart, 4, 6, 6, 5);  
     parNuovaPartita(pathGioc, pathPart, 8, 10, 6, 5);  
     
     p = parDettagliPartita(pathPart,9);
     assert(p->turno==2);
     assert(p->idG1==8);
     assert(p->idG2==10);
     assert(p->risG1==6);
     assert(p->risG2==5);
     delete p;
     
     parNuovaPartita(pathGioc, pathPart, 12, 13, 6, 5);  
     assert(parTurnoCorrente(pathPart)==2);
     assert(parPartiteGiocate(pathPart,(parTurnoCorrente(pathPart)))==4);
     parNuovoTurno(pathPart);
     assert(parTurnoCorrente(pathPart)==3);
     
     
     Lista* l =parListaPartiteGiocate(pathPart, 2);
     assert(l->n==4);
     
     /*numerazione inversa: siccome l'ordine non conta la listapartitegiocate
     fornisce i risultati in ordine inverso per velocizzare l'esecuzione.*/
     Partita*p1 = (Partita*) listeLeggiElemento(l,3);
     assert(p1->turno==2);
     assert(p1->idG1==0);
     assert(p1->idG2==2);
     assert(p1->risG1==6);
     assert(p1->risG2==5);
     delete p1;
     
     Partita*p2 = (Partita*) listeLeggiElemento(l,2);
     assert(p2->turno==2);
     assert(p2->idG1==4);
     assert(p2->idG2==6);
     assert(p2->risG1==6);
     assert(p2->risG2==5);
     delete p2;
     
     Partita*p3 = (Partita*) listeLeggiElemento(l,1);
     assert(p3->turno==2);
     assert(p3->idG1==8);
     assert(p3->idG2==10);
     assert(p3->risG1==6);
     assert(p3->risG2==5);
     delete p3;
     
     Partita*p4 = (Partita*) listeLeggiElemento(l,0);
     assert(p4->turno==2);
     assert(p4->idG1==12);
     assert(p4->idG2==13);
     assert(p4->risG1==6);
     assert(p4->risG2==5);
     delete p4;
     
     listeDistruggiLista(l);
         
     parNuovaPartita(pathGioc, pathPart, 0, 4, 6, 5);     
     parNuovaPartita(pathGioc, pathPart, 8, 12, 6, 5);  
     assert(parTurnoCorrente(pathPart)==3);
     assert(parPartiteGiocate(pathPart,parTurnoCorrente(pathPart))==2);
     parNuovoTurno(pathPart);
     assert(parTurnoCorrente(pathPart)==4);
     parNuovaPartita(pathGioc, pathPart, 0, 8, 6, 5);        
     assert(parTurnoCorrente(pathPart)==4);
     assert(parPartiteGiocate(pathPart,parTurnoCorrente(pathPart))==1);
     
     assert(parContaPartite(pathPart) == 14);
}
