/* Tennis Tournament Management System 2005 by Silvio Moioli
    and Davide Gottini (moio@tiscali.it, davide.gottini@virgilio.it).

	


	ATTENZIONE: questa è la versione DEBUG del programma, pertanto non
	contiene alcuni dei cambiamenti che sono inglogati nella versione
	RELEASE. Si consiglia di usare sempre e solo la versione RELEASE.

	Questa versione è stata pubblicata SOLO per documentare le fasi intermedie
	del lavoro con le assertions e i programmi di prova (come descritto nella
	documentazione)!!!


 */
#include <string>
#include <iostream>
#include "liste.h"
#include "ui.h"
using namespace std;


/** Stampa una scritta a video e la sottolinea */
void uiStampaTitolo(const char* titolo){
	int len = strlen(titolo);
	assert(len<=80);
	cout<<titolo<<endl;
	for (int i = 0; i<len; i++){
		cout<<'-';
	}
	cout<<endl<<endl;
}

/** Stampa un elenco di voci numerate per un menu */
void uiStampaMenu(Lista* voci){
	assert(voci->n>0);
	for (int i=0; i<voci->n; i++){
		char* s = (char*) listeLeggiElemento(voci, i);
		cout<<(i+1)<<'-'<<s<<endl;
	}
	cout<<endl;
}

/** 
 * Chiede all'utente di immettere un numero maggiore o uguale a 
 * sceltaMax. 
 * 
 * @param sceltaMax massimo numero accettabile
 * @return la scelta dell'utente
 */
int uiChiediScelta(int sceltaMax){
	assert(sceltaMax>1);
	int result = -1;
	
	cout<<"Digita una scelta tra 1 e "<<sceltaMax;
	cout<<" e premi INVIO: "<<endl;
	while (result <=0 || result>sceltaMax){
		cin>>result;
		if (cin.fail()){
			/* Errore nel parsing del numero. Probabilmente è stato immesso
			   un carattere non-numerico. Salto il carattere e riprovo
			   (non si può usare cin.ignore() in questo caso). */
			cin.clear();
			char ch;
			cin>>ch;
		}
	}
	return result;
}

/** Chiede all'utente di battere Invio. */
void uiChiediConferma(){
	/*L'algoritmo è praticamente identico al successivo,
	putroppo la libreria standard del C++ non lascia scelta...*/
	char* tmp = new char[MAXCONSOLEINPUT];
	strncpy(tmp, "", MAXCONSOLEINPUT);
    cout<<"Premi un tasto e batti INVIO..."<<endl;
    while (strncmp(tmp,"\n", MAXCONSOLEINPUT) == 0 ||
    	strncmp(tmp,"", MAXCONSOLEINPUT) == 0){
		cin.getline(tmp, MAXCONSOLEINPUT);
    }
    delete[] tmp;
}

/** 
 * Chiede all'utente di digitare una stringa (lunghezza massima 
 * MAXCONSOLEINPUT compreso il '\\0') e la ritorna.
 * Non ammette stringhe vuote.
 * Usa esclusivamente funzioni "sicure" per evitare i buffer overflow.
 */
char* uiChiediStringa(){
	char* result = new char[MAXCONSOLEINPUT];
	strncpy(result, "", MAXCONSOLEINPUT);
    cout<<"Immetti il dato e premi INVIO: "<<endl;
    while (strncmp(result,"\n", MAXCONSOLEINPUT) == 0 ||
    	strncmp(result,"", MAXCONSOLEINPUT) == 0){
		cin.getline(result, MAXCONSOLEINPUT);
    }
    return result;
}

/** Stampa un elenco di voci non numerate */
void uiStampaElenco(Lista* voci){
	assert(voci->n>0);
	for (int i=0; i<voci->n; i++){
		char* s = (char*) listeLeggiElemento(voci, i);
		cout<<s<<endl;
	}
	//riga vuota
	cout<<endl;
}

/** Stampa il banner del programma */
void uiStampaBanner(){
	char* s[13] =
	//Fa un po' schifo... Pace Amen ;)
{" _______               _                                  \
                    ",
"|__   __|             (_)                                 \
                    ", 
"   | | ___ _ __  _ __  _ ___          Tennis Tournament 1.\
0                   ", 
"   | |/ _ \\ '_ \\| '_ \\| / __|         Copyleft 2004-200\
5 Gotto&Moio           ", 
"   | |  __/ | | | | | | \\__ \\                           \
                      ", 
"   |_|\\___|_| |_|_| |_|_|___/                            \
                     ", 
"      ,-----.     _______                                 \
               _    ", 
"     /\\     /\\   |__   __|                              \
                | |   ", 
"    /  \\   /  \\     | | ___  _   _ _ __ _ __   __ _ _ __\
 ___   ___ _ __ | |_  ", 
"   (    : :    )    | |/ _ \\| | | | '__| '_ \\ / _` | '_ \
` _ \\ / _ \\ '_ \\| __| ", 
"    \\   +-+   /     | | (_) | |_| | |  | | | | (_| | | | \
| | |  __/ | | | |_  ", 
"     +-'   `-+      |_|\\___/ \\__,_|_|  |_| |_|\\__,_|_| \
|_| |_|\\___|_| |_|\\__| ",
"      `-----'"};
	
	for (int i =0; i<13; i++){
		cout<<s[i]<<endl;
	}
	cout<<endl;
}
