/* Tennis Tournament Management System 2005 by Silvio Moioli
    and Davide Gottini (moio@tiscali.it, davide.gottini@virgilio.it).

	


	ATTENZIONE: questa è la versione DEBUG del programma, pertanto non
	contiene alcuni dei cambiamenti che sono inglogati nella versione
	RELEASE. Si consiglia di usare sempre e solo la versione RELEASE.

	Questa versione è stata pubblicata SOLO per documentare le fasi intermedie
	del lavoro con le assertions e i programmi di prova (come descritto nella
	documentazione)!!!


 */
#include <stdlib.h>
#include <assert.h>
#include "liste.h"

#ifndef TT_UI
#define TT_UI

/**
 * La massima lunghezza di una stringa leggibile da console.
 * Dovrebbe essere platform-dependant, &egrave; settata a un valore che
 * dovrebbe funzionare su tutte le piattaforme.
 */
const int MAXCONSOLEINPUT = 128;

/**
 * Stampa una scritta a video e la sottolinea.
 * 
 * @param titolo la stringa terminata da '\\0' da stampare e sottolineare.
 */
void uiStampaTitolo(const char* titolo);

/**
 * Stampa un elenco di voci numerate per un menu.
 * 
 * @param voci la lista delle voci del menu (struttura Lista contenente
 * un char* per ogni elemento con la stringa terminata da '\\0'
 */
void uiStampaMenu(Lista* voci);

/**
 * Stampa un elenco di voci non numerate.
 * 
 * @param voci la lista delle voci del menu (struttura Lista contenente
 * un char* per ogni elemento con la stringa terminata da '\\0'
 */
void uiStampaElenco(Lista* voci);

/** 
 * Chiede all'utente di immettere un numero maggiore o uguale a 
 * sceltaMax. 
 * 
 * @param sceltaMax massimo numero accettabile
 * @return la scelta dell'utente
 */
int uiChiediScelta(int sceltaMax);

/** 
 * Chiede all'utente di digitare una stringa (lunghezza massima 
 * MAXCONSOLEINPUT compreso il '\\0') e la ritorna.
 * Non ammette stringhe vuote.
 * 
 * @return la stringa digitata dall'utente
 */
char* uiChiediStringa();

/**
 *  Chiede all'utente di battere un tasto seguito sa Invio.
 */
void uiChiediConferma();

/**
 *  Stampa il banner del programma.
 * 
 */
void uiStampaBanner();

#endif
