/* Tennis Tournament Management System 2005 by Silvio Moioli
   and Davide Gottini (moio@tiscali.it, davide.gottini@virgilio.it). */
#include "liste.h"

/* Per i commenti sulle funzioni pubbliche e i loro i parametri (che sono 
  stati eliminati per  evitare inutili duplicazioni e spreco di spazio)
  si rimanda all'header  della libreria. */

Lista* listeCreaLista(const void* primo){
    Lista* list = new Lista;

    if (primo == NULL){
        list->testa = NULL;
        list->coda = NULL;
        list->n = 0;
    }
    else {
        list->testa = new ElemLista;
        list->coda = list->testa;
        list->n = 1;
        list->testa->elemento = primo;
        list->testa->prossimo = NULL;
    }
    return list;
}

void listeDistruggiLista(Lista* l){
        if (l->n != 0){
        ElemLista* attuale = l->testa;
        ElemLista* prossimo;
        while (attuale != NULL){
            prossimo = attuale->prossimo;
            delete attuale;
            attuale = prossimo;
        }
    }
    delete l;
}

void listeAggiungiElemento(Lista* l, const void* elemento){
    if (l->n == 0){
        l->testa = new ElemLista;
        l->testa->elemento = elemento;
        l->testa->prossimo = NULL;
        l->coda = l->testa;
    }
    else {
        ElemLista* nuovo = new ElemLista;
        l->coda->prossimo = nuovo;
        nuovo->elemento = elemento;
        nuovo->prossimo = NULL;
        l->coda = nuovo;
    }
    l->n++;
}

const void* listeLeggiElemento(Lista* l, int i){
    ElemLista* supp = l->testa;
    for (int j = 0; j < i; j++){
        supp = supp->prossimo;
    }
    return supp->elemento;
}

void listeScriviElemento(Lista* l, int i, const void* elemento){
    ElemLista* supp = l->testa;
    for (int j = 0; j < i; j++){
        supp = supp->prossimo;
    }
    supp->elemento = elemento;
}
