/* Tennis Tournament Management System 2005 by Silvio Moioli
   and Davide Gottini (moio@tiscali.it, davide.gottini@virgilio.it). */
/**
 * File main.cpp
 * Include l'implementazione della funzione main del programma.
 * N.B.: Questa &egrave; l'implementazione "Release", che non 
 * contiene molti controlli  extra (assertions) presenti nella
 * versione "Debug".
 */
#include "menu.h"
using namespace std;

/**
 * Chiede il nome del Torneo, calcola i nomi dei file corrispondenti
 * e lancia il menu principale.
 * @return 0 in caso di funzionamento corretto, 1 in caso di errori
 */
int main(){
	//Chiede il nome del Torneo e calcola i nomi di file
    cout<<"Benvenuto in TennisTournament!"<<endl;
    uiStampaLinea();    
    cout << "Per favore immetti il nome del Torneo (per caricare i dati"
         << endl << "di un  Torneo esistente) o un nuovo nome "
         <<"per un nuovo Torneo." << endl;
    char *nomeTorneo = uiChiediStringa();
    char* nomeFilePartite = new char[MAXCONSOLEINPUT + 12];
    strncpy(nomeFilePartite, nomeTorneo, MAXCONSOLEINPUT);
    strncat(nomeFilePartite, "partite.csv", 12);
    char* nomeFileGiocatori = new char[MAXCONSOLEINPUT + 14];
    strncpy(nomeFileGiocatori, nomeTorneo, MAXCONSOLEINPUT);
    strncat(nomeFileGiocatori, "giocatori.csv", 14);
    delete[] nomeTorneo;

    //Menu principale
    uiStampaBanner();
    bool uscita = false;
    while (!uscita){
        cout << "MENU' PRINCIPALE: " << " Turno: "
            << parTurnoCorrente(nomeFilePartite);
        cout << " Giocate finora " << parContaPartite(nomeFilePartite)
            << " partite"<<endl;
        uiStampaLinea();

        Lista *menu = listeCreaLista("Passa al Menu Partite");
        listeAggiungiElemento(menu, "Passa al Menu Giocatori");
        listeAggiungiElemento(menu,
            "Visualizza le partite dell'intero torneo");
        listeAggiungiElemento(menu, "Esci da TennisTournament");
        uiStampaMenu(menu);
        listeDistruggiLista(menu);

        switch (uiChiediScelta(4)){
            case 1:
                menuPartite(nomeFileGiocatori, nomeFilePartite);
                break;
            case 2:
                menuGiocatori(nomeFileGiocatori, nomeFilePartite);
                break;
            case 3:
                menuRiepilogoTorneo(nomeFileGiocatori, nomeFilePartite);
                break;
            case 4:
                cout<<"Grazie di aver usato TennisTournament!"<<endl;
                uscita = true;
                break;
        }
    }

    //Termina il programma
    delete[] nomeFilePartite;
    delete[] nomeFileGiocatori;
    return 0;
}
