/* Tennis Tournament Management System 2005 by Silvio Moioli
   and Davide Gottini (moio@tiscali.it, davide.gottini@virgilio.it). */
#include <string>
#include <iostream>
#include "liste.h"
#include "ui.h"
using namespace std;

/* Per i commenti sulle funzioni pubbliche e i loro i parametri (che sono 
  stati eliminati per  evitare inutili duplicazioni e spreco di spazio)
  si rimanda all'header  della libreria. */

void uiStampaLinea(){
    cout << "--------------------"<< endl << endl;
}

void uiStampaMenu(Lista* voci){
        for (int i = 0; i < voci->n; i++){
        char* s = (char*) listeLeggiElemento(voci, i);
        cout << (i + 1) << '-' << s << endl;
    }
    cout << endl;
}

int uiChiediScelta(int sceltaMax){
        int result = -1;

    cout << "Digita una scelta tra 1 e " << sceltaMax;
    cout << " e premi INVIO: " << endl;
    while (result <= 0 || result > sceltaMax){
        cin >> result;
        if (cin.fail()){
            /* Errore nel parsing del numero. Probabilmente e' stato immesso
               un carattere non-numerico. Salto il carattere e riprovo
               (non si puo' usare cin.ignore() in questo caso). */
            cin.clear();
            char ch;
            cin >> ch;
        }
    }
    return result;
}

void uiChiediConferma(){
    /* L'algoritmo e' praticamente identico al successivo,
    putroppo la libreria standard del C++ non lascia scelta... */
    char* tmp = new char[MAXCONSOLEINPUT];
    strncpy(tmp, "", MAXCONSOLEINPUT);
    cout << "Premi un tasto e batti INVIO..." << endl;
    while (strncmp(tmp, "\n", MAXCONSOLEINPUT) == 0 ||
            strncmp(tmp, "", MAXCONSOLEINPUT) == 0){
        cin.getline(tmp, MAXCONSOLEINPUT);
    }
    delete[] tmp;
}

char* uiChiediStringa(){
    char* result = new char[MAXCONSOLEINPUT];
    strncpy(result, "", MAXCONSOLEINPUT);
    cout << "Immetti il dato e premi INVIO: " << endl;
    while (strncmp(result, "\n", MAXCONSOLEINPUT) == 0 ||
            strncmp(result, "", MAXCONSOLEINPUT) == 0){
        cin.getline(result, MAXCONSOLEINPUT);
    }
    return result;
}

void uiStampaBanner(){
    char* s[13] =
        	//Fa un po' schifo... Pace Amen ;)
{" _______               _                                  \
                    ",
"|__   __|             (_)                                 \
                    ", 
"   | | ___ _ __  _ __  _ ___          Tennis Tournament 1.\
0                   ", 
"   | |/ _ \\ '_ \\| '_ \\| / __|         Copyleft 2004-200\
5 Gotto&Moio           ", 
"   | |  __/ | | | | | | \\__ \\                           \
                      ", 
"   |_|\\___|_| |_|_| |_|_|___/                            \
                     ", 
"      ,-----.     _______                                 \
               _    ", 
"     /\\     /\\   |__   __|                              \
                | |   ", 
"    /  \\   /  \\     | | ___  _   _ _ __ _ __   __ _ _ __\
 ___   ___ _ __ | |_  ", 
"   (    : :    )    | |/ _ \\| | | | '__| '_ \\ / _` | '_ \
` _ \\ / _ \\ '_ \\| __| ", 
"    \\   +-+   /     | | (_) | |_| | |  | | | | (_| | | | \
| | |  __/ | | | |_  ", 
"     +-'   `-+      |_|\\___/ \\__,_|_|  |_| |_|\\__,_|_| \
|_| |_|\\___|_| |_|\\__| ",
"      `-----'"};

    for (int i =0; i<13; i++){
        cout<<s[i]<<endl;
    }
    cout<<endl;
}
